<?php
/***************************************************************
*  Copyright notice
*
* (c) 2007 Foundation For Evangelism (info@evangelize.org)
* (c) 2009 Georg Ringer <www.ringer.it>
* (c) 2014 Uwe Jakobs : Snippet downsized & customized <leadlab@imageco.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'Typ3 diva' for the 'diva' extension.
 *
 * @author	Uwe Jakobs <diva@imageco.de>
 */
class tx_conftextarea {
	


	/**
	 * Builds an textarea
	 * @param		array		$params:  Contains fieldName and fieldValue.
	 * @param		obj		$pObj:  Objet
	 * @return		string		HTML output
	 */
	function textarea($params, $pObj) {
		/* Pull the current fieldname and value from constants */
		
		$fieldName = $params['fieldName'];
		$fieldValue = $params['fieldValue'];

		// get the configuration
		$conf = $this->getConf($fieldName, $pObj);
		$key = substr($fieldName, 5,-1);
		$formName = ($conf['formName']!='') ? $conf['formName'] : 'editForm';
		
		$css = '';
		unset($conf['formName']);
		foreach ($conf as $keyCSS=>$value) {
			$css .= $keyCSS.':'.$value.'; ';
		}
		
		if ($css!='') {
			$css = ' style="'.$css.'" ';
		} else {
			$css = ' style="width:800px; height:400px;" ';
		}
		
		$fieldValue = str_replace('#####', "\n", $fieldValue);
		$field = '<textarea '.$css.' id="field'.$key.'" name="'. $fieldName .'">'. $fieldValue .'</textarea>';
		
		// add necessary js modification to change linefeeds

		$js = '
		<script type="text/javascript">
			var jsMod;
			
			// assign element from DOM
			jsMod = document.getElementById("configuration-submit-diva");
			
			// attach event handler
			jsMod.addEventListener(\'click\', clickHandler);

			function clickHandler(event) {
				var val = $("field'.$key.'").value;
				str2 = val;  
				while(str2.indexOf("\n") != -1) { 
					str2 = str2.replace("\n", "#####"); 
				}  
	
				$("field'.$key.'").value = str2;
			}

	</script>
		
		';
		
		$field .= $js;

		return $field;
	}
	
	/**
	 * Get the possible configuration of a single field
	 * @param		string		$fieldName:  Name of the field
	 * @param		obj		$pObj:  Objet
	 * @return		array		configuration
	 */
	function getConf($fieldName, $pObj) {
		$key = substr($fieldName, 5,-1);
		$tempConf = '';
		$realConf = array();

		// get the complete line from constants and find the key 'settings'
		$conf = \TYPO3\CMS\Core\Utility\GeneralUtility::trimExplode(';', $pObj->flatSetup[$key.'..']);
		foreach ($conf as $key=>$value) {
			if (strpos($value, 'settings') !== false) {
				$tempConf = $value;
			}
		}
		
		// if settings are found, split them accordingly
		if ($tempConf!='') {
			$tempConf = substr($tempConf, 9);
			
			$tempConf = \TYPO3\CMS\Core\Utility\GeneralUtility::trimExplode(',', $tempConf);
			
			foreach ($tempConf as $key) {
				$split = \TYPO3\CMS\Core\Utility\GeneralUtility::trimExplode(':', $key);
				$realConf[$split[0]] = $split[1];
			}
			
		}
		
		return $realConf;
	}
	
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/diva/class.tx_conftextarea.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/diva/class.tx_conftextarea.php']);
}
?>